package org.zipcoder.store;

import java.util.ArrayList;
import java.util.List;

public class ListMap implements MyMap {
    // instance field that is intialize to an ArrayList
    private List<Entry> entries = new ArrayList<>();

    public ListMap() {

    }

    public List<Entry> getEntries() {
        return entries;
    }

    @Override
    public int size() {
        return entries.size();
    }

    @Override
    public boolean isEmpty() {

        if(size() == 0) {
            return true;
        }

        return false;
    }

    @Override
    public Cart get(User key) {

        for(Entry e : getEntries()) {
            if(e.getKey().equals(key)) {
                return e.getValue();
            }
        }

        return null;
    }

    @Override
    public void put(User key, Cart value) {
        if(get(key) != null) {
            for(Entry e : getEntries()) {
                if(e.getKey() == key) {
                    e.setValue(value);
                }
            }
        } else {
            Entry entry = new Entry(key, value);
            getEntries().add(entry);
        }
    }


    @Override
    public List<User> getKeys() {
        List<User> keys = new ArrayList<>();
        for(Entry e : getEntries()) {
            keys.add(e.getKey());
        }
        return keys;
    }

    @Override
    public List<Cart> getValues() {
        List<Cart> values = new ArrayList<>();
        for(Entry e : getEntries()) {
            values.add(e.getValue());
        }
        return values;
    }

    @Override
    public Cart remove(User key) {

        for(Entry e : getEntries()) {
            if(e.getKey() == key) {
                getEntries().remove(e);
                return e.getValue();
            }
        }

        return null;
    }
}
