package org.zipcoder.store;

import java.util.*;

public class MyHashMap implements MyMap{
    // final field that doesn't change for any object
    private static final int BUCKET_SIZE = 15;

    // instance field that can only be set once. It is different for every Object
    private final List<Entry>[] entries;

    public MyHashMap(){
        entries = new List[BUCKET_SIZE];

        for(int i = 0; i < BUCKET_SIZE; i++) {
            entries[i] = new ArrayList<>();
        }
    }

    public List<Entry>[] getEntries() {
        return entries;
    }

    @Override
    public int size() {
        int count = 0;
        for(int i = 0; i < BUCKET_SIZE; i++) {
            if(!getEntries()[i].isEmpty()) {
                count++;
            }
        }
        return count;
    }

    @Override
    public boolean isEmpty() {

        if(size() == 0) {
            return true;
        }

        return false;
    }

    @Override
    public Cart get(User key) {
        for(Entry e: getEntries()[bucketIndex(key)]) {
            if(e.getKey().equals(key)){
                return e.getValue();
            }
        }

        return null;
    }

    @Override
    public void put(User key, Cart value) {
        if(get(key) != null) {
            for (Entry e : getEntries()[bucketIndex(key)]) {
                if (e.getKey().equals(key)) {
                    e.setValue(value);
                }
            }
        } else {

            Entry entry = new Entry(key, value);
            getEntries()[bucketIndex(key)].add(entry);

        }
    }

    @Override
    public List<User> getKeys() {
        List<User> keys = new ArrayList<>();
        for (int i = 0; i < BUCKET_SIZE; i++) {
            for (Entry e : getEntries()[i]) {
                keys.add(e.getKey());
            }
        }
        return keys;
    }

    @Override
    public List<Cart> getValues() {
        List<Cart> values = new ArrayList<>();
        for (int i = 0; i < BUCKET_SIZE; i++) {
            for (Entry e : getEntries()[i]) {
                values.add(e.getValue());
            }
        }
        return values;
    }

    @Override
    public Cart remove(User key) {
        for (int i = 0; i < BUCKET_SIZE; i++) {
            for (Entry e : getEntries()[i]) {
                if (e.getKey() == key) {
                    getEntries()[i].remove(e);
                    return e.getValue();
                }
            }
        }
            return null;

    }
    private int bucketIndex(User key){
        return Math.abs(key.hashCode()) % entries.length;
    }
}
